package com.example.ueberwachungssystem.Detector.logger;

import android.util.Log;
import android.widget.TextView;

import java.io.PrintWriter;
import java.io.StringWriter;

public class Logger {
    private TextView textView; 
    private StringBuffer sb = new StringBuffer(); 
    private String tag;
    private int lengthOfLastLog = 0;
    private boolean overwrite = false;

    public Logger(String tag, TextView textView, String logInitText)  {
        this.tag = tag;
        this.textView = textView;
        sb.append(logInitText);
    }

    public void log(String s)  {
        overwrite = false;
        Log.d(tag, s);
        sb.append(s).append("\n");
        if (textView != null) {
            textView.setText(sb.toString());
        }
    }

    public void overwriteLastlog(String s)  {
        Log.d(tag, s);
        lengthOfLastLog = s.length();
        if (overwrite)
        {
            sb.setLength(sb.length() - (lengthOfLastLog + 1));
        }
        sb.append(s).append("\n");
        overwrite = true;
        if (textView != null) {
            textView.setText(sb.toString());
        }
    }

    public void log(Exception e)  {
        StringWriter sw = new StringWriter();
        e.printStackTrace(new PrintWriter(sw));
        log(sw.toString());
    }

    public void clearLog()  {
        sb.setLength(0);
        if (textView != null) {
            textView.setText("");
        }
    }

    public String getLoggedText()  {
        return sb.toString();
    }
}
