package com.example.ueberwachungssystem;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Switch;
import android.widget.TextView;

import com.example.ueberwachungssystem.Detector.DetectionReport;
import com.example.ueberwachungssystem.Detector.Detector;
import com.example.ueberwachungssystem.Detector.MicrophoneDetector;
import com.example.ueberwachungssystem.Detector.logger.Logger;
import com.jjoe64.graphview.GraphView;


public class MainActivity extends AppCompatActivity {

    Logger logger;
    GraphView graph;
    private TextView tv_log;
    MicrophoneDetector Mic;
    private Switch TglBtn_Mic;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        tv_log = (TextView) findViewById(R.id.tv_log); //Set textview for showing logged content
        logger = new Logger(this.getClass().getSimpleName(), tv_log, "");
        logger.log(this.getClass().getSimpleName() + ".onCreate");
        graph = (GraphView) findViewById(R.id.graph);
        Mic = new MicrophoneDetector(this, logger, graph);
        setupMic();
        Mic.setOnDetectionListener(new Detector.OnDetectionListener() {
            @Override
            public void onDetection(@NonNull DetectionReport detectionReport) {
                Log.d("Detect", "erkannt!");
            }
        });

    }

    @Override
    public void onResume() {
        super.onResume();
        logger.log(this.getClass().getSimpleName() + ".onResume");
    }

    @Override
    public void onPause() {
        super.onPause();
        logger.log(this.getClass().getSimpleName() + ".onPause");
    }

    private void setupMic() {
        TglBtn_Mic = (Switch) findViewById(R.id.TglBtn_Mic);
        TglBtn_Mic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (v == TglBtn_Mic) {
                    logger.log("onClick toggleButtonThread " + TglBtn_Mic.isChecked());
                    if (TglBtn_Mic.isChecked()) {
                        Mic.startDetection();
                    } else {
                        Mic.stopDetection();
                        logger.clearLog();
                    }
                }
            }
        });
    }
}